function [index] = FCT_cmd_PTP(x,y,z,r,mode)
% function FCT_cmd_PTP
% Cette fonction permet d'excuter une commande PTP.
%
% -> x, y, z, r : coordonnes du point de destination cartsiennes (en mm),
% angulaires (en degr) ou incrmentales (en degr ou mm). Le choix
% entre : cartsien, angulaire ou incrmental, est fait  travers 'mode' ;
% -> mode : mode de dplacement (valeur comprise entre 0 et 9) qui permet
% d'excuter les instructions : JUMP, MOVJ, MOVL avec des coordonnes
% cartsiennes, angulaires ou incrmentales ;
% <- index : indique le numro de l'emplacement de la commande cmd_PTP dans
% la queue.
%
% Rem : La premire variable de sortie de l'API setPTPCmd permet de
% connatre l'tat de fonctionnement de la commande (0 : OK, 1 : pb
% de buffer interne au controlleur du Dobot plein, 2 : pb de TimeOut)

% API SetPTPCmd p.42 de 'Dobot-Magician-API-DescriptionV1.2.3.pdf'
 queue_index=0;   %create queue index
 queue_index_ptr=libpointer('uint64Ptr',queue_index);
%create ptp struct
 ptp.ptpMode=mode;
 ptp.x=x;
 ptp.y=y;
 ptp.z=z;
 ptp.r=r;
%create c type struct
 ptpstruct=libstruct('tagPTPCmd',ptp);
%create ptp pointer
 ptpstructptr=libpointer('tagPTPCmdPtr',ptpstruct);
%send ptp cmd
 [~,~,index]=calllib('DobotDll','SetPTPCmd',ptpstructptr,true,queue_index_ptr);
end

