function [res1, res2, res3, res4] = FCT_connecter()
% function FCT_connecter
% Une fois le robot trouv (via API SearchDobot), cette fonction permet de
% connecter le robot (via API ConnectDobot).
%
% <- res1: device number;
% <- res2: device address;
% <- res3: contact result (0:success 1:error 2:timeout);
% <- res4: portName (for the serial port, portName is COM3, for
% UDP, portName is 192.168.0.5).

% API SearchDobot p.3 de 'Dobot-Magician-API-DescriptionV1.2.3.pdf'
% API ConnectDobot p.3
%load DobotDll
 if ~libisloaded('DobotDll')
   [notfound, warnings]=loadlibrary('DobotDll.dll','DobotDll.h');
 end
%libfunctionsview DobotDll

%create size 128 charArrays
 ch=blanks(128);
%create pointer point to charArrays
 str1= libpointer('cstring',ch);

%search the magician device (res1:device number, res2:device address)
 [res1,res2]=calllib('DobotDll','SearchDobot',str1,128);
%create pointer point to device address
 str2= libpointer('cstring',res2);

%contact device (res3:contact result (0:success 1:error 2:timeout))
 [res3,res4]=calllib('DobotDll','ConnectDobot',str2, 115200);
end

